<?php

namespace AMZcockpitDoctrine\Repository\MWS;

use AMZcockpitDoctrine\Entity\MWS\Store;

/**
 * StoreRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class StoreRepository extends \Doctrine\ORM\EntityRepository
{
    public function getActiveStores() {

        $qb = $this->createQueryBuilder('s')
            ->leftJoin('s.user','u');
        $qb->select('s')
            ->where($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere(($qb->expr()->eq('s.validated',':validated')))
            ->setParameter('validated',true);

        return $qb->getQuery()->getResult();
    }

    public function getActiveStoresByProductCount($hasBigProductNumber = false) {

        $qb = $this->createQueryBuilder('s')
            ->leftJoin('s.user','u')
            ->innerJoin('s.products','p');
        $qb->select('s, COUNT(p) as _count')
            ->where($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere(($qb->expr()->eq('s.validated',':validated')))
            ->setParameter('validated',true)
        ->groupBy('s');

        if($hasBigProductNumber) {
            $qb->having('COUNT(p) < 100');
        } else {
            $qb->having('COUNT(p) > 100');
        }
        $qb->orderBy("_count","ASC");
        return $qb->getQuery()->getResult();
    }

    /**
     * @param int $delay in hours
     * @return array
     */
    public function getStoresNotYetImported($delay = 36) {

        $createdAt = (new \DateTime('now'))->sub(new \DateInterval('PT'.$delay.'H'));
        $qb = $this->createQueryBuilder('s');
        $qb->select('s')
            ->leftJoin('s.user','u')
            ->where(($qb->expr()->lte('s.createdAt',':start_date')))
            ->setParameter('start_date',$createdAt)
            ->andWhere(($qb->expr()->eq('s.status',':status')))
            ->setParameter('status',Store::PENDING)
            ->andWhere(($qb->expr()->eq('s.problemNotified',':problemNotified')))
            ->setParameter('problemNotified',false)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false);

        return $qb->getQuery()->getResult();
    }
}
